#define WIN32_LEAN_AND_MEAN
#define GLUT_DISABLE_ATEXIT_HACK

#include<windows.h>
#include "gl.h"
#include "glu.h"
#include "glut.h"

void init();
void display();
void keyFunc(unsigned char, int, int);
void drawCircle(int, int, int);
void symmetry(int,int,int,int);

void main(int argc, char** argv) {

	glutInit(&argc, argv);
	glutInitWindowSize(640, 480);
	glutInitWindowPosition(100,100);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	glutCreateWindow("My Test");
	init();
	glutDisplayFunc(display);
	glutKeyboardFunc(keyFunc);
	glutMainLoop();
	
}
void init() {

	glClearColor(1.0,1.0,1.0,0.0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-320,320,-240,240,-320,320);
}
void display() {

	glClear(GL_COLOR_BUFFER_BIT);
	glColor3f(1,0,0);
	
	/*glBegin(GL_QUADS);

		

		glVertex3i(-3,-3,0);
		glVertex3i(3,-3,0);
		glVertex3i(3,3,0);
		glVertex3i(-3,3,0);
	glEnd();

	glBegin(GL_TRIANGLES);

		glColor3f(1,0,0);

		glVertex3i(-3,-3,0);
		glVertex3i(-3,3,0);
		glVertex3i(-9,0,0);


		glVertex3i(-3,-3,0);
		glVertex3i(3,-3,0);
		glVertex3i(0,-9,0);

		glVertex3i(3,3,0);
		glVertex3i(3,-3,0);
		glVertex3i(9,0,0);

		glVertex3i(3,3,0);
		glVertex3i(-3,3,0);
		glVertex3i(0,9,0);

	glEnd();*/

	

	drawCircle(-100,0,85);

	glFlush();
	glutSwapBuffers();
}
void keyFunc(unsigned char c, int x, int y) {

	switch(c){
	
	case 'r':
		glRotatef(5,1,1,1);
		break;
	case 't':
		glTranslatef(2,2,2);
		break;
	case 's':
		glScalef(1.5,1,1);
		break;
	}

	display();
}
void drawCircle(int xc, int yc, int rad) {

	int x=0;
	int y=rad;
	int p=1-rad;

	symmetry(x,y,xc,yc);

	for(x=0;y>x;x++) {
	
		if(p < 0)
			p+=2*x+3;
		else {
			p+=2*(x-y) +5;
			y--;
		}
		symmetry(x,y,xc,yc);
	}
}
void symmetry(int x, int y, int xc, int yc) {

	glBegin(GL_POLYGON);
		
		glVertex3i(xc+x,yc-y,0);				//x,y
		glVertex3i(xc+y,yc-x,0);				//y,x
		glVertex3i(xc+y,yc+x,0);				//y,-x
		glVertex3i(xc+x,yc+y,0);				//x,-y
		glVertex3i(xc-x,yc+y,0);				//-x,-y
		glVertex3i(xc-y,yc+x,0);				//-y,-x
		glVertex3i(xc-y,yc-x,0);				//-y,x
		glVertex3i(xc-x,yc-y,0);				//-x,y
	glEnd();
}